<template>
  <div class="fixed top-0 z-30 w-full header header-style-four">
    <div class="bg-background1 relative z-[60]">
      <div
        v-loading="isLoading"
        class="container relative mx-auto"
        :class="{ '!w-[1200px]': store.state.selectedThemeName === 'black' }"
      >
        <div class="w-full flex justify-between h-10">
          <div class="flex">
            <utils-tiny-hamburger-user-center v-if="auth" />
            <div
              class="max-w-[440px] announcement-container ol-bg-light flex items-center px-2 gap-2"
            >
              <utils-announcement
                v-if="!announcement.IsHidden"
                :announcement="announcement.Text"
              />
            </div>
          </div>
          <div class="flex gap-2">
            <div
              class="flex items-center justify-end mt-3 mb-2.5"
              @mouseover="isFeatureContentEnabled = false"
            >
              <div v-if="auth" class="flex flex-col items-center">
                <span class="text-xs w-full text-right">{{
                  store.state.username
                }}</span>
                <div class="flex items-center">
                  <utils-balance-information
                    :is-suspended="isSuspendedAccount"
                  />
                </div>
              </div>
              <div v-if="auth" class="flex items-center">
                <nuxt-link
                  v-if="isCashPlayer && isShowDepositWithdrawal"
                  id="depositBtn"
                  to="/deposit"
                  class="px-2 py-0.5 mx-2 rounded-2xl btn --secondary --textBtn"
                >
                  <b class="--textBtn font-medium">{{ $t(`deposit${isBhinbhin}`) }}</b>
                </nuxt-link>
                <nuxt-link
                  v-if="!agentCooperation.IsHidden"
                  to="/agent-cooperation"
                  class="px-2 py-0.5 mr-2 btn --tertiary rounded-2xl --textBtn whitespace-nowrap"
                  ><b class="--textBtn">{{ $t("agent_cooperation") }}</b>
                </nuxt-link>
              </div>
            </div>
            <div v-if="!auth" class="flex items-center">
              <nuxt-link
                id="loginBtn"
                to="/login"
                class="px-2 py-0.5 mr-2 btn rounded-2xl --secondary --textBtn h-6"
                ><b class="--textBtn font-medium capitalize">{{ $t("capital_login") }}</b></nuxt-link
              >
              <nuxt-link
                v-if="!register.IsHidden"
                id="signupBtn"
                to="/register"
                class="px-2 py-0.5 mr-2 rounded-2xl btn --primary --textBtn h-6"
                ><b class="--textBtn font-medium capitalize">{{ $t("joinnow") }}</b></nuxt-link
              >
            </div>
            <div
              class="max-w-[440px] announcement-container ol-bg-light flex items-center px-4"
            >
              <div class="flex gap-2 justify-between">
                <utils-display-time
                  :need-vertical-line="false"
                  class="text-right"
                />
                <div>|</div>
                <div>
                  <utils-language />
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="flex items-center justify-between h-[64px] bg-background3">
        <div class="container relative mx-auto h-full">
          <div class="h-full flex">
            <nuxt-link
              v-if="!logo.IsHidden"
              class="flex items-center pr-2"
              :to="logo.HyperLink ? `/${logo.HyperLink}` : '/'"
            >
              <div class="flex justify-start h-[56px] items-center min-w-[168px]">
                <img :src="logo.ImagePath" class="w-full h-full" />
              </div>
            </nuxt-link>
            <div class="flex items-center">
              <ul
                class="flex items-center justify-end capitalize whitespace-nowrap h-full"
              >
                <li
                  class="px-4 cursor-pointer nav-item --text3 h-full flex items-center"
                  @mouseover="isFeatureContentEnabled = false"
                >
                  <nuxt-link
                    class="header-height w-max menu-tab-hover-animated !h-full"
                    to="/"
                    :class="[
                      {
                        'active-menu': tabSelected === '/',
                      },
                      { uppercase: isVietnamLangBlackTheme },
                    ]"
                  >
                    <div class="flex pr-1 items-center">
                      <div class="content pr-1">
                        <div class="icon-container">
                          <SvgIcon
                            svg-name="icon-home"
                            class="w-[16px] h-[16px]"
                          />
                        </div>
                      </div>
                      <span
                        :class="
                          tabSelected !== '/' ? 'font-normal' : 'font-bold'
                        "
                        >{{ $t("home") }}</span
                      >
                    </div>
                  </nuxt-link>
                </li>
                <li
                  v-for="tab in menuTabHeaders"
                  :key="tab"
                  class="px-4 cursor-pointer nav-item --text3 h-full flex items-center"
                  @mouseover="productListFeatureHover(tab.TabType, tab.TabURL)"
                >
                  <nuxt-link
                    :to="tab.TabURL"
                    :class="[
                      {
                        'active-menu':
                          tabSelected === tab.TabURL?.toLowerCase() ||
                          testActiveGame(tab.TabType, activeTab),
                      },
                      { uppercase: isVietnamLangBlackTheme },
                    ]"
                    class="header-height w-max menu-tab-hover-animated --text3 !h-full"
                  >
                    <div class="flex flex-nowrap justify-center">
                      <div class="flex pr-1 items-center">
                        <div class="content">
                          <div class="icon-container">
                            <SvgIcon
                              :svg-name="getIcon(tab.TabType)"
                              class="w-4 h-4"
                            />
                          </div>
                        </div>
                      </div>
                      <span
                        :class="
                          tabSelected === tab.TabURL?.toLowerCase() ||
                          testActiveGame(tab.TabType, activeTab)
                            ? 'font-bold'
                            : 'font-normal'
                        "
                        >{{ $t(tab.TabLanguage) }}</span
                      >
                    </div>
                  </nuxt-link>
                </li>
                <li
                  v-if="isAllowPromotionTab"
                  class="px-4 cursor-pointer nav-item --text3 h-full flex items-center"
                  @mouseover="isFeatureContentEnabled = false"
                >
                  <nuxt-link
                    to="/promotion"
                    :class="[
                      { 'active-menu': tabSelected === '/promotion' },
                      { uppercase: isVietnamLangBlackTheme },
                    ]"
                    class="header-height w-max menu-tab-hover-animated !h-full"
                  >
                    <div class="flex items-center">
                      <div class="content pr-1">
                        <div class="icon-container">
                          <SvgIcon
                            svg-name="icon-promotion-2"
                            class="w-4 h-4"
                          />
                        </div>
                      </div>
                      <span
                        :class="
                          tabSelected !== '/promotion'
                            ? 'font-normal'
                            : 'font-bold'
                        "
                        >{{ $t("promotion") }}</span
                      >
                    </div>
                  </nuxt-link>
                </li>
                <li
                  v-if="isAppDownloadEnabled"
                  class="px-4 cursor-pointer nav-item --text3 h-full flex items-center"
                  @mouseover="isFeatureContentEnabled = false"
                >
                  <nuxt-link
                    to="/app-download"
                    :class="{ 'active-menu': tabSelected === '/app-download' }"
                    class="header-height w-max menu-tab-hover-animated !h-full"
                  >
                    <div class="flex items-center">
                      <div class="content pr-1">
                        <div class="icon-container">
                          <SvgIcon svg-name="icon-download" class="w-4 h-4" />
                        </div>
                      </div>
                      <span
                        :class="
                          tabSelected !== '/app-download'
                            ? 'font-normal'
                            : 'font-bold'
                        "
                        >{{ $t("app_download") }}</span
                      >
                    </div>
                  </nuxt-link>
                </li>
              </ul>
            </div>
          </div>
        </div>
      </div>
    </div>
    <product-feature-tab-hover
      v-model:is-feature-hover="isFeatureContentEnabled"
      :component-key="componentKey"
      :feature-products="filterProductFeature"
    />
  </div>
  <div class="h-[104px]"></div>
</template>

<script lang="ts">
import { PropType, computed, defineComponent } from "vue";
import { store } from "@/store";
import themePropertyHelper from "@/utils/themePropertyHelper";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import {
  useHeaderComponent,
  handleGameEntryOpenWindow,
} from "@/composables/useTheme";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import commonHelper from "@/utils/commonHelper";
import EnumThemePropertyKey from "~~/models/enums/enumThemePropertyKey";

export default defineComponent({
  name: "HeaderStyleFour",
  props: {
    propertyKeys: {
      type: Array as PropType<Array<string>>,
      required: true,
    },
  },
  setup(props) {
    const { getAssetImage, isBhinbhin } = commonHelper;
    const {
      menuTabHeaders,
      tabSelected,
      isLoading,
      filterProductFeature,
      productListFeatureHover,
      isFeatureContentEnabled,
      isAllowPromotionTab,
      referralEnabled,
      agentCooperation,
      register,
      auth,
      isSuspendedAccount,
      isSportLiveEnabled,
      isAppDownloadEnabled,
      username,
      logout,
      isCashPlayer,
      isShowDepositWithdrawal,
      componentKey,
      isReferralV2Enabled,
    } = useHeaderComponent();
    const route = useRoute();
    const activeTab = computed(() => route.query.tab ?? "");
    const testActiveGame = (tabType: string, activeGame: string): boolean => {
      const temTabType = tabType
        .trim()
        .toLowerCase()
        .replaceAll(" ", "")
        .replaceAll("-", "");
      const temActiveGame = activeGame
        .trim()
        .toLowerCase()
        .replaceAll(" ", "")
        .replaceAll("-", "");
      return temActiveGame === temTabType;
    };
    const properties = computed(() => props.propertyKeys);
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );

    const logo = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          properties.value[0]
        )
    );
    const announcement = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          properties.value[1]
        )
    );
    const facebook = computed(() =>
      featuresToggleHelper.getThemePropertyFromApi(
        EnumThemePropertyKey.HtmlId,
        "facebook_link"
      )
    );
    const isVietnamLangBlackTheme = computed(
      () =>
        store.state.locale === "vi_VN" &&
        store.state.selectedThemeName === "black"
    );
    const getLabel = (tabType: string) => {
      return tabType.replace(" ", "_").toLowerCase();
    };
    const getIcon = (tabType: string) => {
      return `icon-${tabType.toLowerCase().replace(" ", "-")}`;
    };
    return {
      menuTabHeaders,
      tabSelected,
      isLoading,
      filterProductFeature,
      productListFeatureHover,
      isFeatureContentEnabled,
      isAllowPromotionTab,
      announcement,
      referralEnabled,
      agentCooperation,
      register,
      auth,
      isSuspendedAccount,
      isSportLiveEnabled,
      activeTab,
      testActiveGame,
      logo,
      handleGameEntryOpenWindow,
      EnumEntranceLocation,
      isAppDownloadEnabled,
      getAssetImage,
      isShowDepositWithdrawal,
      isCashPlayer,
      username,
      logout,
      componentKey,
      isVietnamLangBlackTheme,
      store,
      isReferralV2Enabled,
      facebook,
      getLabel,
      getIcon,
      isBhinbhin,
    };
  },
});
</script>
<style lang="scss">
.header-style-four {
  .icon-lang {
    outline: 1px solid var(--border);
  }
  .announcement-container {
    --bg-base-color: var(--background1);
    --bg-opacity: 0.05;

    .announcement-icon {
      width: 32px;
      margin-right: 0;
      position: relative;
      display: flex;
      align-items: center;
      justify-content: center;
      margin-right: 1px;

      &:after {
        content: "";
        position: absolute;
        right: 0;
        width: 1px;
        background: var(--border);
        height: 12px;
      }
    }

    .vue3-marquee {
      margin-left: 8px;
      padding-right: 8px;
    }
  }
  .display-time-container {
    padding-left: 0;
    .display-time-text {
      padding-left: 0;
    }
  }
  .icon-lang {
    height: 16px;
    width: 16px;
  }
  .el-tooltip__trigger:has(#headerBalanceDisplay) {
    #headerBalanceDisplay {
      font-size: 12px;
      color: var(--text);
    }
    svg {
      color: var(--text);
    }
  }
  .balance-currency {
    padding-right: 4px;
  }
  .menu-tab-hover-animated {
    color: var(--text3) !important;
    .icon-container {
      svg {
        fill: var(--text3);
      }
    }
    &::after {
      top: 0 !important;
    }
    &::before {
      display: none;
    }
    svg {
      opacity: 0.5;
    }
    &:hover {
      svg {
        opacity: 1;
      }
      &::after {
        display: none;
      }
    }
  }
  .active-menu {
    color: var(--text3) !important;
    &.menu-tab-hover-animated {
      &::after {
        background: var(--primary);
      }
      svg {
        opacity: 1;
      }
    }
  }
}
</style>
<style lang="postcss" scoped>
.bg-header {
  background-color: var(--background3);
}
.header-height {
  height: 40px;
  display: flex;
  align-items: center;
  position: relative;
}
.nav-item .active-menu,
.nav-item:hover .header-height {
  color: var(--selected);
}
.nav-item .active-menu::before,
.nav-item:hover .header-height::before {
  background-color: var(--selected);
  bottom: 0;
  content: "";
  height: 0.125rem;
  left: 0;
  position: absolute;
  width: 100%;
}
.m-notice {
  height: 36px;
}
.fb-btn {
  min-width: 100px;
}
:deep(.star-icon) {
  right: -12px;
}
</style>
